﻿function processAliensTurn()
{   
    var aliens = [];
    var actors = G.actorNames();
    for (var i=0; i<actors.length; i++) {
        if (actors[i]!="robot" && actors[i]!="bullet") {
            var alien = G.actor(actors[i]);
            if (alien.enabled)
                aliens.push(alien);
        }
    }
    for (var i=0; i<aliens.length; i++) {
        var alien = aliens[i];
        if ( alien.attribute("state")=="turning right" ) {
            alien.setAttribute("state", "turning right again");
        }
        else {
            var wall = false;
            var targetCellX, targetCellY;

            var canMove = true;
            var direction = alien.attribute("direction");
            if (direction=="north") {
                targetCellX = alien.x;
                targetCellY = alien.y + 1;
                wall = G.Scene.cellBorderState(alien.x, alien.y, 0, "front") > 0;
            }
            else if (direction=="south") {
                targetCellX = alien.x;
                targetCellY = alien.y - 1;
                wall = G.Scene.cellBorderState(alien.x, alien.y, 0, "back") > 0;
            }
            else if (direction=="east") {
                targetCellX = alien.x + 1;
                targetCellY = alien.y;
                wall = G.Scene.cellBorderState(alien.x, alien.y, 0, "right") > 0;
            }
            else if (direction=="west") {
                targetCellX = alien.x - 1;
                targetCellY = alien.y;
                wall = G.Scene.cellBorderState(alien.x, alien.y, 0, "left") > 0;
            }
            // Проверяем, что гад не вышел за границы поля
            if (targetCellX<0 || targetCellY<0)
                canMove = false;
            if (targetCellX>=G.Scene.width || targetCellY>=G.Scene.length)
                canMove = false;
            
            if (alien.attribute("state")=="turning right again") {
                alien.setAttribute("state", "moving");
                alien.evaluateCommand("turnRight", false);
            }
            else if (!canMove) {
                alien.setAttribute("state", "turning right");
                alien.evaluateCommand("turnRight", false);
            }
            else {
                alien.setAttribute("state", "moving");
                alien.evaluateCommand("moveForward", false);
            }
        }
    }
    
}

function waitForAliens()
{
    var aliens = [];
    var actors = G.actorNames();
    for (var i=0; i<actors.length; i++) {
        if (actors[i]!="robot" && actors[i]!="bullet") {
            var alien = G.actor(actors[i]);
            if (alien.enabled)
                aliens.push(alien);
        }
    }
    var robot = G.actor("robot");
    for (var i=0; i<aliens.length; i++) {
        while (aliens[i].isEvaluating()) {
            robot.sleep_msec(50);
        }
    }
}
