﻿function doShoot()
{
    var direction = this.attribute("direction");
    var aliens = [];
    var actors = G.actorNames();
    for (var i=0; i<actors.length; i++) {
        if (actors[i]!="robot" && actors[i]!="bullet") {
            var alien = G.actor(actors[i]);
            if (alien.enabled)
                aliens.push(alien);
        }
    } 
    
    var bullet = G.actor("bullet");
    
    
    var bulletStartX = this.x;
    var bulletStartY = this.y;
    var bulletDX, bulletDY;
    var bulletDirection = direction;
    
    if (direction=="north") {
        bulletStartY++;
        bulletDX = 0;
        bulletDY = 1;
    }
    
    if (direction=="south") {
        bulletStartY--;
        bulletDX = 0;
        bulletDY = -1;
    }
    
    if (direction=="east") {
        bulletStartX++;
        bulletDX = 1;
        bulletDY = 0;
    }
    
    if (direction=="west") {
        bulletStartX--;
        bulletDX = -1;
        bulletDY = 0;
    }
    
    if (bulletStartX<0 || bulletStartX>=G.Scene.width)
        return; // Выстрел в стену
    
    if (bulletStartY<0 || bulletStartY>=G.Scene.length)
        return; // Выстрел в стену
        
    bullet.x = bulletStartX;
    bullet.y = bulletStartY;
    bullet.z = 0;
    bullet.visible = true;
    if (bulletDirection=="south")
        bullet.setCurrentFrame(1);
    else if (bulletDirection=="east")
        bullet.setCurrentFrame(2);
    else if (bulletDirection=="north")
        bullet.setCurrentFrame(3);
    else if (bulletDirection=="west")
        bullet.setCurrentFrame(4);
    
    
    var bulletTargetX = bulletStartX;
    var bulletTargetY = bulletStartY;
    
    // Определяем координаты цели
    
    while (true) {
        var foundAlien = false;
        for (var i=0; i<aliens.length; i++) {
            var alien = aliens[i];
            if (alien.x == bulletTargetX && alien.y == bulletTargetY) {
                foundAlien = true;
                break;
            }
        }
        
        if (foundAlien)
            break;
        
        bulletTargetX += bulletDX;
        bulletTargetY += bulletDY;
        
    }
    
    // Ракета (или пуля), в отличии от робота, не снижает свою скорость
    // при достижении очередной клетки. Поэтому будем перемещать её
    // по клеткам с сохранением скорости.
    
    const A_acc = 0.00008; // процентов/мсек**2
    const V_max = 0.01; // процентов/мсек
    const deltaT = 30;
    
    var V_t0 = 0;
    var V_t = 0;
    var X_t = 0;
    var X_t0 = 0;
    var deltaX = 0;
    
    var nextX = bulletStartX;
    var nextY = bulletStartY;
    
    // Полетели...
    
    while (nextX!=bulletTargetX || nextY!=bulletTargetY) {
        
        // Очередная клетка, которую пролетает пуля
        nextX += bulletDX;
        nextY += bulletDY;
        
        bullet.beginMove(nextX, nextY, 0);
        
        // Полёт между соседними клетками
        while ( X_t<1.0 ) {
            // Скорость движения
            V_t0 = V_t;
            V_t = V_t0 + A_acc*deltaT;
            if (V_t >= V_max)
                V_t = V_max;
            // На сколько смещаемся
            deltaX = V_t * deltaT;
            X_t0 = X_t;
            X_t = X_t0 + deltaX;
            //Logger.writeToStdOut("...: "+X_t);
            bullet.moveBy(deltaX);
            bullet.sleep_msec(deltaT);
        }
        // Завершаем перемещение в клетку
        bullet.endMove();
        if (X_t>1.0)
            X_t0 = X_t - 1.0;
        else
            X_t0 = 0.0;
        X_t = X_t0;
        deltaX = 0;
    }
    
    // Прилетели. Теперь смотрим, кого пристрелили... и убираем со сцены.
    for ( var i=0; i<aliens.length; i++) {
        var alien = aliens[i];
        if (alien.x == bulletTargetX && alien.y == bulletTargetY) {
            alien.visible = false;
            alien.enabled = false;
        }
    }
    
    // Скрываем ракету -- она уже "отработала"
    bullet.visible = false;
    
}
